/* *
 *STA_articleNS.js 
 *
 *
 *@author Oliver Lutzi
 *
 */


$(document).ready(function() {
	

	//See comments in function to see why we need this
	correctMwContentText();
	
	//Only load STA script files, if the page belongs to category [[Category:STA-Annotatable]]
	var category_annotatable = "STA-Annotatable";
	var flag = false;
	
	$.ajax({
		type: 'GET',
        url: mw.util.wikiScript('api'),
        async: false,
        clcategories:'Category'+category_annotatable,
        data: {
            'action': 'query',
            'titles': wgPageName,
            'prop': 'categories',
            'format':'json'
        },
        success: function getFormCallback(request) { 
        	
        	for (var i = 0; i < request.query.pages[wgArticleId].categories.length; i++) {
        		if (request.query.pages[wgArticleId].categories[i].title == 'Category:'+category_annotatable) {
        			flag = true;
        			break;
        		}
        	}
        }
	});
	
	//Abort, if the page is not tagged with [[Category:STA-Annotatable]]
	if (!flag) {
		return;
	}
	
	
	//Append buttons	
	var STA_headline_code 	=  '&nbsp;&nbsp;&nbsp;<a style="color:#009B80;cursor:default;text-decoration:none;" id="STA_button">&nbsp;&nbsp;Semantic Text Annotator</a>&nbsp;&nbsp;&nbsp;\n';
	var STA_buttons_code	=  		'&nbsp;&nbsp;&nbsp;'	
								+	'<input type="button" value="New Annotation" 		id="annotation_mode" 	style="position:relative">'
								+	'<input type="button" value="View Annotations" 		id="view_annotations" 	style="position:relative">'
								//testbutton: remove // in next line
								+	'<input type="button" value="test" 					id="testbutton" 			style="position:relative">';
			
	
	if (wgVersion.substring(0,4) >= 1.19) {
		
		switch (skin) {
		  //case "vector": 					$('#p-views>ul').append('<li><span>'+STA_headline_code+'</span></li>'); break;
		  case "vector": 					$('#p-views').append('<span>'+STA_headline_code+'</span>'); break;
		
		  case ("monobook"||"modern"):		$('#p-cactions>.pBody>ul').append('<li><span>'+STA_headline_code+'</span></li>'); break;
		  case "chick":						$('#bodyContent').prepend(STA_headline_code); break;
		  case "cologneblue":				$('#langlinks').prepend(STA_headline_code); break;
		  case "standard":					$('#topbar').append(STA_headline_code); break;
		  case "myskin":					$('#column-content').prepend(STA_headline_code); break;
		  case "nostalgia":					$('#top').append(STA_headline_code); break;
		  case "simple":					$('#bodyContent').prepend(STA_headline_code); break;
		  default:							alert("Please change your skin to Vector: Preferences>Appearances");
		}
		$('#STA_button').append(STA_buttons_code);
	} else { 
		alert("The installed extension 'Semantic Text Annotator' is not compatible with the installed version of MediaWiki. Please update to MediaWiki 1.19 or higher.");
	}
	
	$('#annotation_mode').click(function () {
		annotation_mode();
	});
	
	$('#view_annotations').click(function () {
		highlightAnnotations();
	});
	
	$('#testbutton').click(function () {
		//ext.popupform.handlePopupFormLink('/mediawiki/index.php/Special:FormEdit/TextAnnotation/Testseite', this); 			
		//alert(document.getElementById("mw-content-text").innerHTML);
		alert(flagForSMWSyntax);
	});

	checkHighlightAnnotationsNowTag();
			
});//End ready()


function checkHighlightAnnotationsNowTag() {
	//this function is needed to call the function highlightAnnotations automatically after a reload of the page
	var actualPage = ajaxCall_standard("getEditContent",[wgPageName]);
	var posTag = actualPage.search("<!--STAHIGHLIGHTANNOTATIONSNOW")
	if (posTag != "-1") {
			var startPosAnnotationSerialNumber = posTag+30;
			var endPosAnnotationSerialNumber = posTag+38;
			var annotationSerialNumber = actualPage.substring(startPosAnnotationSerialNumber,endPosAnnotationSerialNumber);
			//remove tags
			actualPage = actualPage.substring(0,actualPage.length-41);
			ajaxCall_standard("sta_editWikiPage",[wgPageName,actualPage,""]);			
			highlightAnnotations();
			mouseOverLine(annotationSerialNumber);
	 }	
}


function setHighlightAnnotationsNowTag(annotationSerialNumber) {
	var actualPage = ajaxCall_standard("getEditContent",[wgPageName]);
    actualPage = actualPage + "<!--STAHIGHLIGHTANNOTATIONSNOW"+annotationSerialNumber+"-->";
    ajaxCall_standard("sta_editWikiPage",[wgPageName,actualPage,""]);
}









