function selectedText () {
	if (window.getSelection) {
		return (window.getSelection());
	} else if (document.getSelection) {
		return (document.getSelection());
	} else if (document.selection) {
		return (document.selection.createRange().text);
	}
}

function annotate(sel, selRange, plainText, editText, aTag, eTag, startPos, endPos){
	 
	 var positionOfSelection			 	= getPositionOfSelection(startPos,endPos);

	 var beginOfSelection		 			= positionOfSelection[0];
	 //var endOfSelection		 			= positionOfSelection[1];
	 if(positionOfSelection[0] == "ERROR") {
		 return "ERROR";
	 }
	 
	 var textBeforeSelection  				= plainText.substring(0,beginOfSelection);
	 //var textNachSelektiertemBereich 		= plainText.substring(endOfSelection,plainText.length);
	 	 
	 var symbolsBeforeSelection  			= textBeforeSelection.split("");
	 var symbolsWithinSelection				= sel.split("");
	 
	 var editTextMitTags 					= editText;
	 var position 							= 0;
	 
	 //Search for all symbols that appear before the selected area
	 //Insert start-Tag (aTag, a for the german word 'Anfang' = beginning) after you found the last of these symbols
	 for (var i=0;i<symbolsBeforeSelection.length;i++) {
		 var lengthOfSymbol = symbolsBeforeSelection[i].length;		 
		 position = skipWikiSyntax(editText, position);
		 var foundAtPosition = editText.indexOf(symbolsBeforeSelection[i],position);
		 if (foundAtPosition != -1) {
			 position = foundAtPosition + lengthOfSymbol;
		 } else {
			 return "ERROR";
		 }
	 }
	 
	 position = skipWikiSyntax(editText, position);
	 //search for the first symbol of the selection and insert aTag before that symbol
	 position = editTextMitTags.indexOf(symbolsWithinSelection[0],position);
	 editTextMitTags = editTextMitTags.substring(0, position) + aTag + editTextMitTags.substring(position, editTextMitTags.length);
	 
	 //The new content of the edit field is now longer
	 position = position + aTag.length;
	 	 	 
	 //Im Text aus dem Edit-Feld nach den Woertern suchen, die im selektierten Bereich liegen.
	 //Nach dem letzten markierten Wort wird der end-Tag eingefgt.
	 for (i=0;i<symbolsWithinSelection.length;i++) {
		 var lengthOfSymbol = symbolsWithinSelection[i].length;
		 var newPosition = skipWikiSyntax(editTextMitTags, position);
		 position = newPosition;		 
		 position = editTextMitTags.indexOf(symbolsWithinSelection[i],position) + lengthOfSymbol;		 
	 }
	 
	 position = skipWikiSyntax(editTextMitTags, position);
	 editTextMitTags = editTextMitTags.substring(0, position) + eTag + editTextMitTags.substring(position, editTextMitTags.length);
	 
	 
	 return editTextMitTags;	 
}



//global flag, necessary for the handling of smw syntax
var flagForSMWSyntax = false;

//skips all declared wiki syntax
//if there is wiki specific syntax at the actual *position* we need to skip that syntax
//example: abc <br /> efg b --> position = 3 --> search for "b" --> first hit would be the b from <br />
//			--> to avoid this, we skip <br />, because we identify that this is wiki specific syntax and skip that part in our search
function skipWikiSyntax(text, position) {
		
	//always write pairs of syntax and the length you need to skip!
	//in case of the aTag and eTag syntax, we search for "{{aTag|" but we skip 17
	var listOfWikiSyntax = new Array(	"<br />",	"6",
								"<br>",		"4",
								"{{aTag|",	"17", //{{aTag|12B1RDPL}}
								"{{eTag|",	"17",
								"[[","x",
								"]]","x" //no comma after last element in list!
							);
	
	var thereMightBeWikiSyntax = true;
	
	while (thereMightBeWikiSyntax) {
		thereMightBeWikiSyntax = false;
		for (var i=0;i<listOfWikiSyntax.length;i=i+2) {
			var relevantText = text.substring(position,position+listOfWikiSyntax[i].length);
			/**alert(		"text:\n" + text + "\n\n" 
					+	"position: " + position + "\n\n"
					+	"listOfWikiSyntax["+i+"]: " + listOfWikiSyntax[i] + "\n\n"
					+ 	"listOfWikiSyntax["+i+"].length: " + listOfWikiSyntax[i].length + "\n\n"
					+	"relevantText: "+relevantText
					);*/

			if (relevantText == listOfWikiSyntax[i]) {
				//handle SMW-syntax
				//if there could be syntax for a smw-property...
				if(listOfWikiSyntax[i] == "[["){
					
					//...then check if there is a property
					var textToCheck = text.substring(position, text.length);
					
					//var derSatz = "[[a12sdf3_13-af::asdfdf3_13-af]]";
					var search = /\[\[(.+)::(.+)\]\]/;
					var result = search.exec(textToCheck);
					
					//how long is the part "[[.......::"  ?
					var lengthOfPartBeforeThePropertysName = RegExp.$1.length;
					
					//add the calculated length to the position variable
					position = position + 2 + lengthOfPartBeforeThePropertysName + 2; // 2 for the [[ and 2 for the ::
					
					//set the global flag "true", so when the function "skipWikiSyntax" is called the next time
					//it knows that the syntax "]]" really are the closing tags of a semantic property
					flagForSMWSyntax = true;
					break;
				}
				
				
				//if the brackets "]]" are the closing syntax for a semantic property: skip them
				else if(listOfWikiSyntax[i] == "]]" && flagForSMWSyntax) {
					position = position + 2;
					flagForSMWSyntax = false;
					break;
				}
				
				//handle other syntax from list
				else {
					position = position + parseInt(listOfWikiSyntax[i+1]);
					thereMightBeWikiSyntax = true;
					break; //leave for-loop to reset flag and start for-loop from i=0 again	
				}
			}
		}
	}
	return position;
}


//Function copied from Semantic Image Annotator
function SIA_randomString(string_length) {
	    "use strict";
	    var chars, randomstring, rnum, i;
	    chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	    randomstring = '';
	    for (i = 0; i < string_length; i += 1) {
	        rnum = Math.floor(Math.random() * chars.length);
	        randomstring += chars.substring(rnum, rnum + 1);
	    }
	    return (randomstring);
	}


function createUniqueAnnotationPageName() {
	var pageExists;
	
	//Generate annotation page name and check if it exists - if it does, pick another.
	pageExists = true;
	annotationPageName = "";
	while (pageExists) {
		
        var response, jsonRes;
        randomString = SIA_randomString(8);
        annotationPageName = 'TextAnnotation' 	  + ':' + wgTitle + '-' + randomString;
        
        response = $.ajax({
            type: "GET", // request type ( GET or POST )
            url: wgScriptPath + '/api.php',
            async: false,
            data: {
                'action': 'query',
                'titles': annotationPageName,
                'format': 'json'
            }
        });
        jsonRes = $.parseJSON(response.responseText);
        if (jsonRes.query.pages.hasOwnProperty("-1") && jsonRes.query.pages['-1'].hasOwnProperty('missing')) {
            pageExists = false;
        }
    }
	
	return annotationPageName;
}


function createAnnotationPage(annotationPageName) {
	var sfFormsLink;
	
	//date
	var annotationDate = new Date();
	annotationDate = annotationDate.toGMTString();
	
	//needed to edit template with SemanticForms
	sfFormsLink = wgScript + '/' + wgFormattedNamespaces['-1'] + ':FormEdit/' + 'TextAnnotation';
    sfFormsLink = sfFormsLink + '/' + annotationPageName; 	//--> mediawiki/index.php/Special:FormEdit/TextAnnotation/TextAnnotation:Oliver_Lutzi
    
	$.ajax({
        type: "GET",
        url: 'index.php',
        datatype: 'text',
        data: {
            'action': 'ajax',
            'rs': 'sta_writeAnnotationProperties',
            'rsargs': {
            	annotationSerialNumber: randomString,
            	newPageName: annotationPageName, 
            	articleName: wgTitle,	//wgTitle is deprecated
            	annotationDate: annotationDate,
            	createdBy: wgUserName, 
            }
        },
        success: function getFormCallback(request) {
            if (request === 'success') {
            	//When the essential properties have been stored **automaticly**, open a SemanticForm to add additional details manually
            	setHighlightAnnotationsNowTag(randomString);
            	 //name of the annotation page
           	 	var nameOfAnnotationPage = "TextAnnotation:" + wgPageName + "-" + randomString;
           	 	getAnnotatedText(nameOfAnnotationPage);

           	    ext.popupform.handlePopupFormLink(sfFormsLink, this);
           	    //example:
           	    //ext.popupform.handlePopupFormLink('/mediawiki/index.php/Special:FormEdit/TextAnnotation/TextAnnotation:Testseite', this); 
            }
        }
    });//End ajax()
		
}

function changeAnnotation(annotationSerialNumber) {
	
	var annotationPageName = 'TextAnnotation' 	  + ':' + wgTitle + '-' + annotationSerialNumber;//(8);	//im Original wurde staTextAnnotationNS-Var verwendet //ACHTUNG wgTitle ist depreciate!
	
	var sfFormsLink = wgScript + '/' + wgFormattedNamespaces['-1'] + ':FormEdit/' + 'TextAnnotation';
    sfFormsLink = sfFormsLink + '/' + annotationPageName; 	//--> mediawiki/index.php/Special:FormEdit/TextAnnotation/TextAnnotation:Oliver_Lutzi

	var annotationDate = new Date();
	annotationDate = annotationDate.toGMTString();
	var user = wgUserName;
	
	var editText = ajaxCall_standard("getEditContent",[annotationPageName]);
	
	var startProp1 = editText.search("\\[\\[STAannotationDate::");
	startProp1 = startProp1 + 21;
	var endProp1 = editText.indexOf("]]",startProp1);
	
	editText = editText.substring(0,startProp1) +annotationDate+"| "+editText.substring(endProp1,editText.length);		
	
	var startProp2 = editText.search("\\[\\[STAcreatedBy::");
	startProp2 = startProp2 + 16;
	var endProp2 = editText.indexOf("]]",startProp2);
	
	editText = editText.substring(0,startProp2)+user+"| "+editText.substring(endProp2,editText.length);
	
	ajaxCall_standard("sta_editWikiPage",[annotationPageName,editText,"Created by Semantic Text Annotator"]);
	
	setHighlightAnnotationsNowTag(annotationSerialNumber);
	
	ext.popupform.handlePopupFormLink(sfFormsLink, this);
}


function deleteAnnotation(annotationSerialNumber) {
	
	var pagename = wgPageName;
	var editText = ajaxCall_standard("getEditContent",[pagename]);
	
	var aTag = "{{aTag|"+annotationSerialNumber+"}}";	
	editText = editText.replace(aTag, "");
	
	var eTag = "{{eTag|"+annotationSerialNumber+"}}";
	editText = editText.replace(eTag, "");

	ajaxCall_standard("sta_editWikiPage",[pagename,editText,"Created by Semantic Text Annotator"]);

	var annotationPageName = 'TextAnnotation' 	  + ':' + wgTitle + '-' + annotationSerialNumber;
	
	$.ajax({
        type: "GET", // request type ( GET or POST )
        url: 'index.php',
        datatype: 'text',
        data: {
            'action': 'ajax',
            'rs': 'sta_deleteAnnotationPage',
            'rsargs': {
            	pageName: annotationPageName, 
            	userName: wgUserName,
            }
        },
        success: highlightAnnotations(),
    });
}


